ALTER PROCEDURE [dbo].[P_PIRAMIDE_CLIENTS_WRITEOFF](@R int=1, --
@UniKey	int=null OUTPUT,			-- 
@DateBegin	datetime=null,			-- 
@DateEnd	datetime=null,			-- 
@LimitFixed	int=null,				--  
@LimitPercent	int=null,			--  %    
@Factor	float=null,					--
@UserKey	int=null,				-- 
@SelectOrder varchar(512)=null		--   
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <11.04.2016>
-- Update date: <15.12.2016>
-- Description:	<        >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON;
DECLARE @Q varchar(4000), @LngMain varchar(2);
SELECT TOP 1 @LngMain=LngMain FROM PROPERTIES;
	--
	if @R=1
		begin
		SET @Q='SELECT PW.*,(SELECT COUNT(*) FROM ConditionsOrder PC WHERE PC.CoreKey=PW.UniKey AND CoreTypeKey=2) as ConditionsCount FROM PiramideClientsWriteOff PW WHERE 1=1';
		if (@SelectOrder is NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY PW.DateBegin DESC';
		Exec (@Q); ;
		return;
		end;
	--
	if @R=2
		begin
		INSERT INTO PiramideClientsWriteOff (DateBegin,DateEnd,LimitFixed,LimitPercent,Factor)
			VALUES (@DateBegin,@DateEnd,@LimitFixed,@LimitPercent,@Factor);
		SET @UniKey=SCOPE_IDENTITY();
		return;
		end;
	-- 
	if @R=3
		begin
		UPDATE PiramideClientsWriteOff 
			SET DateBegin=@DateBegin,DateEnd=@DateEnd,LimitFixed=@LimitFixed,LimitPercent=@LimitPercent,Factor=@Factor
			WHERE UniKey=@UniKey;
		return;
		end;
	--
	if @R=4
		begin
		DELETE FROM ConditionsOrder WHERE CoreKey=@UniKey AND CoreTypeKey=2;
		--DELETE FROM PiramideClientsWriteOffConditions WHERE PiramideClientsWriteOffKey=@UniKey;
		DELETE FROM PiramideClientsWriteOff WHERE UniKey=@UniKey;
		return;
		end;
END
