ALTER PROCEDURE [dbo].[P_CarRequirementsOS](
@R int=1,		--
@CarRequirementKey	int=null,
@OtherServiceKey	int=null
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <12.10.2016>
-- Update date: <22.12.2016>
-- Description:	<  .      >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON
	if @R=1 /**/
		begin
		SELECT sss.*, MM.MeasureFullName,MM.MeasureName 
			FROM OtherServices sss 
			LEFT JOIN Measure MM ON sss.measure=MM.UniKey 
			 AND MM.Lng=(SELECT TOP 1 LngMain FROM PROPERTIES)
			WHERE sss.UniKey IN (SELECT OtherServiceKey FROM CarRequirementOSLink WHERE CarRequirementKey=@CarRequirementKey);
		return;
		end;
	if @R=3 /**/
		begin
		INSERT INTO CarRequirementOSLink (OtherServiceKey,CarRequirementKey) 
				VALUES (@OtherServiceKey,@CarRequirementKey);
		--UPDATE TablesLastUpdate SET TLU_OTHER_SERVICE=GETDATE();
		return;
		end;
	if @R=4 /**/
		begin
		DELETE FROM CarRequirementOSLink  where CarRequirementKey=@CarRequirementKey
				AND OtherServiceKey=@OtherServiceKey;
		--UPDATE TablesLastUpdate SET TLU_OTHER_SERVICE=GETDATE();
		return;
		end;
	if @R=5 /*    */
		begin
		SELECT sss.*, MM.MeasureFullName,MM.MeasureName,l.CarRequirementKey
			FROM OtherServices sss 
			LEFT JOIN Measure MM ON sss.measure=MM.UniKey 
			 AND MM.Lng=(SELECT TOP 1 LngMain FROM PROPERTIES)
			INNER JOIN CarRequirementOSLink L ON L.OtherServiceKey=sss.UniKey
		return;
		end;
END
