ALTER PROCEDURE [dbo].[P_Phone_Patterns](@R int=1, @Unikey int=null OUTPUT, 
@IFNumDigit varchar(2)=NULL, @NumDigit int=0, @IFSymDigit int=0, 
@SymDigit varchar(128)='', @Action int=0, @PosDigit int=1, @CountDigit int=0, @InsertDigit varchar(128)='',
@InOut bit=0,@Pos int=1, @isEnabledOperator bit=1, @isEnabledSMS bit=0, @isEnabledRobot bit=0,
@isEnabledCashOut bit=0, @isEnabledDrivers bit=0,
@SelectOrder varchar(1024)=NULL, @Phone varchar(128)=null)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <12.10.2011>
-- Update date: <16.12.2016>
-- Description:	<      >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON;
DECLARE @Q varchar(4000), @KeyTmp int, @Prev int, @MaxPos int;
	--
	if @R=1
		begin
		SET @Q='SELECT PP.*,PT.PhoneTypeName FROM Phone_Patterns PP LEFT JOIN PhoneTypes PT ON PT.UniKey=PP.PhoneType AND PT.Lng LIKE (SELECT TOP 1 LngMain FROM PROPERTIES) WHERE 1=1';
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY PP.InOut';
--		RaISERROR 99999 @Q;
		Exec (@Q);
		end;
	-- 
	if @R=2
		begin
		INSERT INTO Phone_Patterns (IFNumDigit,NumDigit,IFSymDigit,SymDigit,[Action], PosDigit,CountDigit,
			InsertDigit,InOut,Pos,isEnabledOperator,isEnabledSMS,isEnabledRobot,isEnabledCashOut,isEnabledDrivers)
			VALUES (@IFNumDigit,@NumDigit,@IFSymDigit,@SymDigit,@Action, @PosDigit,@CountDigit,
				@InsertDigit,@InOut,@Pos,@isEnabledOperator,@isEnabledSMS,@isEnabledRobot,@isEnabledCashOut,@isEnabledDrivers);
		SET @Unikey=SCOPE_IDENTITY();
		end;
	--
	if @R=3
		begin
		UPDATE Phone_Patterns SET IFNumDigit=@IFNumDigit,NumDigit=@NumDigit,
		IFSymDigit=@IFSymDigit,SymDigit=@SymDigit,[Action]=@Action, PosDigit=@PosDigit,CountDigit=@CountDigit,
			InsertDigit=@InsertDigit,InOut=@InOut,
			Pos=@Pos,isEnabledOperator=@isEnabledOperator,isEnabledSMS=@isEnabledSMS,isEnabledRobot=@isEnabledRobot,
			isEnabledCashOut=@isEnabledCashOut,isEnabledDrivers=@isEnabledDrivers WHERE UniKey=@Unikey;
		end;
	--
	if @R=4
		begin
		DELETE FROM Phone_Patterns WHERE UniKey=@Unikey;
		end;
	-- 
	if @R=5
		begin
		SELECT [dbo].[GetPhoneFromPattern](@Phone,@IFNumDigit,@NumDigit,@IFSymDigit,@SymDigit,@Action, @PosDigit,@CountDigit,
			@InsertDigit) as Phone;
		end;
	-- 
	if @R=6
		begin
		SELECT [dbo].[GetPhoneFromPatternS](@Phone,@InOut,@isEnabledOperator,@isEnabledSMS,@isEnabledRobot,@isEnabledCashOut,@isEnabledDrivers) as Phone;
		end;
end;		